id: {{ entity_type }}_{{ bundle_name }}
label: Migrate {{ bundle_label }} from XML dump
migration_group: ismi_migration
status: true

destination:
  plugin: entity:{{ entity_type }}
  bundle: {{ bundle_name }}
  translations: false

source:
  plugin: url
  urls:
    - "{{ source_xml_base }}-{{ bundle_name }}.xml"

  track_changes: false
  data_fetcher_plugin: file
  data_parser_plugin: xml
  item_selector: '/openmind-data/entities/entity'
  fields:
    -
      name: label
      label: default value/label
      selector: 'text()'
    -
      name: ismi_id
      label: Unique content ID
      selector: '@id'
    -
      name: object_class
      label: object type
      selector: '@object-class'
    -
      name: public
      label: object is public
      selector: '@public'
{% for field_name, field_info in field_info_xmls if field_name != 'ismi_id' %}
{% if field_info.type != 'entity_reference' %}
    -
      name: migrate_{{ bundle_name }}_{{ field_name }}
      label: {{ bundle_name }}_{{ field_name }}
      selector: 'attributes/attribute[@name="{{ field_info.xml_attribute }}"]/text()'
{% endif %}
{% endfor %}

  ids:
    ismi_id:
      type: string

  constants:
    format_text_long: plain_text

process:
  _skip:
    -
      # match type
      plugin: skip_on_value
      source: object_class
      not_equals: true
      value: '{{ xml_original_type }}'
      method: row
    -
      # match public=true
      plugin: skip_on_value
      source: public
      not_equals: true
      value: 'true'
      method: row
      
  type:
    -
      plugin: default_value
      default_value: {{ bundle_name }}

  title:
    -
      # use type if label is empty
      plugin: default_value
      default_value: {{ bundle_name }}
      source: label
    -
      plugin: callback
      callable: trim
    - 
      # limit to 250 char
      plugin: substr
      length: 250

  {{ bundle_name }}_ismi_id: ismi_id

{% for field_name, field_info in field_info_xmls  if field_name != 'ismi_id' %}
{% if field_info.type != 'entity_reference' %}
{% if field_info.type == 'text_long' %}
  '{{ field_info.drupal_field_name }}/value': migrate_{{ bundle_name }}_{{ field_name }}
  '{{ field_info.drupal_field_name }}/format': constants/format_text_long
{% elseif field_info.type == 'datetime' %}
  {{ field_info.drupal_field_name }}:
    -
      source: migrate_{{ bundle_name }}_{{ field_name }}
      plugin: ismi_date_handler
{% else %}
  {{ field_info.drupal_field_name }}:
    -
      source: migrate_{{ bundle_name }}_{{ field_name }}
      callable: trim
      plugin: callback
{% endif %}

{% endif %}
{% endfor %}